#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <network.h>
#include <socket.h>
#include "porter.h"

typedef struct {
	void	*next;
	char	buf[SET_LEN];
} ADRCHAIN;


static int sock25;


/* clear address chain */
static void
clr_chain (ADRCHAIN **mother)
{
	ADRCHAIN	*parent, *child;

	parent = *mother;
	while (parent) {
		child = parent->next;
		free(parent);
		parent = child;
	}
	*mother = NULL;
}

/* skip spaces in string */
static char *skipspace (char *str)
{
	char	*p = str;

	while (*p && *p <= ' ')	p++;
	return p;
}

/* extract mail address from mime header */
static char *getaddress (char *dest, char *str)

{
	char *r = skipspace (str);
	char *w = dest;

	while (TRUE) {
		if (!*r || *r == ',') {
			break;
		} else if (*r == '\"') {
			/* skip quoted string */
			while (*r && *r != '\"')	r++;
			if (*r)	r = skipspace (++r);

		} else if (*r == '(') {
			/* skip (comment) */
			while (*r && *r != ')')	r++;
			if (*r)	r = skipspace (++r);

		} else if (*r == '<') {
			/* get <address> */
			r = skipspace (++r);
			w = dest;
			while (*r && *r != '>')	*w++ = *r++;
			if (*r)	r = skipspace (++r);

		} else {
			*w++ = *r++;
		}
	}

	/* delete post-placed spaces */
	while (dest < w && w[-1] <= ' ')	--w;
	*w = '\0';

	/* skip comma */
	if (*r)	r++;
	return r;
}

/* clear chain */
static int add_chain(struct _porter *q, ADRCHAIN **mother, char *str)
{
	ADRCHAIN *parent = *mother;
	char *p = str;

	while (*p) {
		ADRCHAIN *child = malloc (sizeof(ADRCHAIN));

		if (!child) {
			fputs ("܂\n", stdout);
			clr_chain (mother);
			return FALSE;
		}
		p = getaddress (child->buf, p);
		if (!child->buf[0]) {
			free (child);
			break;
		}

		/* add domain name if not found */
		if (!strchr (child->buf, '@')) {
			strcat (child->buf, q->HostName);
		}

		child->next = NULL;
		if (parent) {
			parent->next = child;
		} else {
			*mother = child;
		}
		parent = child;
	}
	return TRUE;
}


/* w肳ꂽ\Pbg烁bZ[W󂯎 */
/* Ԃl : X|XR[h */
static int ReceiveMessage (int sock, char *mes)
{
	int ret;

	recvline (sock, mes, STR_LEN);		/* M */
	VerbosePrintf ("M : %s", mes);
	sscanf (mes, "%d %*s", &ret);

	return (ret);
}



/* w肳ꂽ\PbgɃbZ[W𑗂 */
static void SendMessage (int sock, char *mes)
{
	VerbosePrintf ("M : %s", mes);
	write_s (sock, mes, strlen (mes));	/* M */

	return;
}



/*
   w肳ꂽ\PbgɃR}h𑗂
     : *cmd = MR}h
   @@@@@*mes = M̕Ԃobt@
   @@@@@   cmd  mes ͓AhXłnji㏑邾j
   Ԃl  : X|XR[h
 */
static int SendCommand (int sock, char *cmd, char *mes)
{
	int ret;

	SendMessage (sock, cmd);
	ret = ReceiveMessage (sock, mes);

	return (ret);
}



/* \PbgI[v */
static int OpenSock (char *hostname, int port)
{
	int sock;
	struct hostent *h;
	struct sockaddr_in addr;

    /* \Pbg쐬 */
	sock = socket (AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		printf ("	G[ : \Pbg쐬ł܂ł\n");
		return (-1);
	}
	memset (&addr, 0, sizeof (addr));	/* 0 Ŗ߂ */

	addr.sin_family = AF_INET;	/* INEThCw */
	addr.sin_port = htons (port);	/* |[gԍ */
    /* zXgimankai.co.jpj  IP AhX(int)ɕϊ */
	h = gethostbyname (hostname);
	if (h == NULL) {
		printf ("	G[ : hC݂܂\n");
		return (-1);
	}
	addr.sin_addr.s_addr = *(long *) h->h_addr;

    /* ɐڑ */
	printf ("	ڑ...\n");
	if (connect (sock, (char *) &addr, sizeof (addr)) < 0) {
		printf ("	G[ : ڑɎs܂\n");
		return (-1);
	}
	printf ("ڑ܂\n");
	return (sock);
}



/* \PbgN[Y */
static void CloseSock (int sock)
{
	if (sock > 0) {
	    //while (socklen (sock, 0));    /* Mobt@Ƀf[^邤͑҂ */
	    //while (socklen (sock, 1));    /* M@@@@@@@V@@@@@@@@ */
	    //shutdown (sock, 0);   /* Mf[^󂯎炸CׂĔp */
	    //shutdown (sock, 1);   /* TCP FIN𑗐MCf[^̑o߂ */
	    //shutdown (sock, 2);   /* connection  abort */
		close_s (sock);
	}
}



int PostOne (struct _porter *q, char *fname)
{
#define STR_LEN	1024
	int ret;
	FILE *fp;
	ADRCHAIN	*to_chain = NULL, *child;
	char *ptr;
	char line_buffer[STR_LEN];

	VerbosePrintf ("PostOne()\n");
	fp = fopen (fname, "rt");
	if (fp == NULL) {
		printf ("%s ǂݍ߂܂\n", fname);
		return (-1);
	}

	while (fgets822a (line_buffer, sizeof(line_buffer), fp)) {
		if ((ptr = GetKeyword (line_buffer, "TO:"))
				|| (ptr = GetKeyword (line_buffer, "BCC:"))
				|| (ptr = GetKeyword (line_buffer, "CC:"))) {
			if (!add_chain (q, &to_chain, ptr)) {
				fclose (fp);
				return (-2);
			}
		}
	}
	if (!to_chain) {
		fputs ("悪܂\n", stdout);
		fclose (fp);
		return (-1);
	}

	/* back to the top of file */
	fseek(fp, SEEK_SET, 0);

    /* Mw */
	sprintf (line_buffer, "MAIL FROM:<%s>\r\n", q->MailAdress);
	ret = SendCommand (sock25, line_buffer, line_buffer);
	if (ret != 250) {
		printf ("	G[ : MAIL R}h\nT[o[ : %s\n", line_buffer);
		fclose (fp);
		clr_chain (&to_chain);
		return (-1);
	}

    /* Mw */
	child = to_chain;
	while (child) {
		sprintf (line_buffer, "RCPT TO:<%s>\r\n", child->buf);
		ret = SendCommand (sock25, line_buffer, line_buffer);
		if (ret != 250) {
			printf ("	G[ : RCPT R}h\nT[o[ : %s\n", line_buffer);
			fclose (fp);
			clr_chain (&to_chain);
			return (-1);
		}
		child = child->next;
	}
	clr_chain (&to_chain);

	sprintf (line_buffer, "DATA\r\n");
	ret = SendCommand (sock25, line_buffer, line_buffer);
	if (ret != 354) {
		printf ("	G[ : DATA R}h\nT[o[ : %s\n", line_buffer);
		fclose (fp);
		return (-1);
	}

	/* wb_𑗂 */
	while (fgets (line_buffer, sizeof(line_buffer), fp)) {
		if (ferror (fp) || feof (fp))	break;
		if (headicmp (line_buffer, "BCC:")) {
			/* o͂Ȃ */
			while (fgets (line_buffer, sizeof(line_buffer), fp)) {
				if (line_buffer[0] != ' ' && line_buffer[0] != '\t')
					break;
			}
			if (ferror (fp) || feof (fp))	break;
			if (line_buffer[0] == '\n')		break;
		}
		SendMessage (sock25, line_buffer);
	}
	SendMessage (sock25, "\r\n");	/* wb_̏I */

	/* fname PsǂݍőM */
	while (fgets (line_buffer, sizeof(line_buffer), fp) != NULL) {
		if (ferror (fp) || feof (fp))
			break;
		if (!strcmp (line_buffer, ".\r\n"))	/* "." Ȃ ".." ɒu */
			strcpy (line_buffer, "..\r\n");

		SendMessage (sock25, line_buffer);	/* M */
	}
	SendMessage (sock25, ".\r\n");	/* f[^I */
	ret = ReceiveMessage (sock25, line_buffer);
	if (ret != 250) {
		printf ("	G[ : DATA R}h\nT[o[ : %s\n", line_buffer);
		fclose (fp);
		return (-1);
	}
	fclose (fp);

	return (0);
}



int LoginSession (char *hostname)
{
	int ret;
	char line_buffer[STR_LEN];

	VerbosePrintf ("LoginSession()\n");

/* main() łĂ̂ŏȗ
	if (_get_version () < 0) {
		printf ("	G[ : TCP/IP hCo풓Ă܂\n");
		return (LOGIN_INETD);
	}
*/
	sock25 = OpenSock (hostname, 25);
	if (sock25 < 0)
		return (LOGIN_SOCK);

    /* 肩̃EFJbZ[WM */
	ret = ReceiveMessage (sock25, line_buffer);
	if (ret != 220) {
		printf ("	G[ : ڑۂ܂\nT[o[ : %s\n", line_buffer);
		return (LOGIN_ERROR);
	}
	sprintf (line_buffer, "HELO %s\r\n", hostname);
	ret = SendCommand (sock25, line_buffer, line_buffer);
	if (ret != 250) {
		printf ("	G[ : HELO R}h\nT[o[ : %s\n", line_buffer);
		return (LOGIN_ERROR);
	}
	return (LOGIN_OK);
}


int LogoffSession (void)
{
	char line_buffer[STR_LEN];

	SendCommand (sock25, "QUIT\r\n", line_buffer);
	CloseSock (sock25);

	return (0);
}
